// network.h from LiVES
// see file ../COPYING for license
// All LiVES code (c) G. Finch (salsaman@xs4all.nl) 


#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <netdb.h>

#define MAX_SOCKETS 128
#define MAXDATASIZE 250 // max number of bytes we can send at once
#define SOCKET_TIMEOUT 30 // time we wait to connect, in sec.s

// TODO - make prefs
#define VEEJAY_PORT 22000 // the port client will be connecting to 
#define VEEJAY_HOST "localhost" // the host client will be connecting to 

#define LiVES_SOCKET_COMMAND 0
#define LiVES_SOCKET_STATUS 1

#define VEEJAY_SOCKET_SEND 2
#define VEEJAY_SOCKET_RECV 3


// lives type sockets
typedef struct {
  struct hostent *he;
  struct sockaddr_in server_addr;
  int handle;
} lives_socket;








// functions
void 
network_init (void);


void 
network_end (void);


gboolean 
socket_connect( lives_socket *v, const char *name, int port_id );


gboolean  
socket_read(lives_socket *v);



// network client functions
gboolean 
network_add_vj_client (void);

void 
vj_client_send(const char *buf);





