// paramwindow.h
// LiVES
// (c) G. Finch 2004 <salsaman@xs4all.nl>
// see file COPYING for licensing details


typedef struct {
  gint usr_number;
  GSList *rbgroup;
  gint active_param;
} lives_widget_group_t;


void on_paramwindow_ok_clicked (GtkButton *, lives_rendered_effect_t *);
void on_paramwindow_cancel_clicked (GtkButton *, lives_rendered_effect_t *);

void on_render_fx_activate (GtkMenuItem *, lives_rendered_effect_t *);

void on_render_fx_pre_activate (GtkMenuItem *, lives_rendered_effect_t *);

void make_param_box(GtkVBox *, lives_rendered_effect_t *);

void add_param_to_box (GtkBox *, lives_rendered_effect_t *, gint param_number);

void add_hsep_to_box (GtkBox *);
void add_fill_to_box (GtkBox *);
void add_label_to_box (GtkBox *, const gchar *text);

GSList *add_usrgrp_to_livesgrp (GSList *u2l, GSList *rbgroup, gint usr_number);

lives_widget_group_t *livesgrp_from_usrgrp (GSList *u2l, gint usrgrp);

void after_boolean_param_toggled (GtkToggleButton *, lives_rendered_effect_t * rfx);

void after_param_value_changed (GtkSpinButton *, lives_rendered_effect_t * rfx);

void after_param_red_changed (GtkSpinButton   *, lives_rendered_effect_t * rfx);

void after_param_green_changed (GtkSpinButton   *, lives_rendered_effect_t * rfx);

void after_param_blue_changed (GtkSpinButton   *, lives_rendered_effect_t * rfx);

void after_param_alpha_changed (GtkSpinButton   *, lives_rendered_effect_t * rfx);

void on_pwcolourbutton_clicked (GtkButton *button, lives_rendered_effect_t *);
void on_pwcolsel_ok_clicked (GtkButton *button, lives_rendered_effect_t *);
void on_pwcolsel_cancel_clicked (GtkButton *button, gpointer unused);

gchar *param_marshall (lives_rendered_effect_t *rfx, gboolean with_min_max);
void param_demarshall (lives_rendered_effect_t *rfx, GList *plist, gboolean update_widgets);

void spin_act_toggle (GtkSpinButton *, GtkToggleButton *);

void toggle_set_default_value (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_red (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_green (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_blue (GtkToggleButton *, GtkSpinButton *);
void toggle_set_default_alpha (GtkToggleButton *, GtkSpinButton *);


// object should have g_set_object_data "param_number" set to parameter number
// (1 based, -ve for init onchanges)

void do_onchange (GObject *object, lives_rendered_effect_t *);


void add_gulong_data_to_widget(GtkWidget *,gchar *data_name, gulong);
gulong get_gulong_data_from_widget(GtkWidget *,gchar *data_name);

